package cn.bs.bsmanagebasic.aspect;

import lombok.extern.slf4j.Slf4j;
import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.annotation.Around;
import org.aspectj.lang.annotation.Aspect;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

/**
 * @author sunjj
 * @version 1.0.0
 * @ClassName EnableESAop.java
 * @Description 拦截com.parksong.services.delivery.DeliveryESService/并根据配置判断是否使用es服务（数据同步，查询等）
 * @createTime 2019年10月24日 10:22:00
 */
@Component
@Aspect
@Slf4j
@ConfigurationProperties(prefix = "es-server")
public class EnableESAop {

    private boolean enable = false;

    public boolean isEnable() {
        return enable;
    }

    public void setEnable(boolean enable) {
        this.enable = enable;
    }

    @Around("execution(* cn.bs.bsmanagebasic.service.DeliveryESService.*(..))")
    public Object around(ProceedingJoinPoint pjp) {
        try {
            if (enable) {
                return pjp.proceed();
            }
        } catch (Throwable throwable) {
            throwable.printStackTrace();
        }
        return null;
    }
}
