package cn.bs.bsmanagebasic.common.enums;

import java.util.ArrayList;
import java.util.List;

/**
 * @author sunjj
 * @version 1.0.0
 * @ClassName DeliveryStatusEnum.java
 * @Description TODO
 * @createTime 2019年11月18日 15:54:00
 */
public enum DeliveryStatusEnum {
    STATUS_120("未到货", 120),
    STATUS_245("待入库", 245),
    STATUS_122("在库", 122),
    STATUS_124("派送中", 124),
    STATUS_125("麦客配送中", 125),
    STATUS_126("出库", 126),
    STATUS_246("退回", 246),
    STATUS_130("拒收离库", 130),
    STATUS_128("拒收在库", 128),
    STATUS_225("滞留", 225);

    private String value;
    private int key;

    DeliveryStatusEnum(String value, int key) {
        this.value = value;
        this.key = key;
    }

    public static DeliveryStatusEnum valueOf(int code) {
        for (DeliveryStatusEnum statusCode : DeliveryStatusEnum.values()) {
            if (statusCode.getKey() == code) {
                return statusCode;
            }
        }
        return null;
    }

    public static String of(int code) {
        for (DeliveryStatusEnum returnCode : DeliveryStatusEnum.values()) {
            if (returnCode.getKey() == code) {
                return returnCode.getValue();
            }
        }
//		 return code;
        return "";
    }

    public static List<EnumsData> getType() {
        List<EnumsData> list = new ArrayList<EnumsData>();
        for (DeliveryStatusEnum type : DeliveryStatusEnum.values()) {
            EnumsData enumsData = new EnumsData();
            enumsData.setKey(type.getKey());
            enumsData.setValue(type.getValue());
            list.add(enumsData);
        }
        return list;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public int getKey() {
        return key;
    }

    public void setKey(int key) {
        this.key = key;
    }
}
