package cn.bs.bsmanagebasic.common.util;

import cn.bs.bsmanagebasic.common.util.redis.JedisClient;
import cn.bs.bsmanagebasic.entity.*;
import cn.bs.bsmanagebasic.entity.dto.StoreTemplateDto;
import cn.bs.bsmanagebasic.entity.sys.SysParam;
import cn.bs.bsmanagebasic.entity.sys.SysType;
import com.alibaba.fastjson.JSON;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Service;
import org.springframework.web.context.ContextLoader;
import org.springframework.web.context.WebApplicationContext;

import java.util.List;
import java.util.Set;


/**
 * 缓存数据的操作类
 * @author Administrator
 *
 */
public class CacheTool {
    private JedisClient jedis = null;

	private String jedisKey;
	private Class className;

	private static final String CACHE_NAMESPACE = "haliaeetus:";
	private static final String CACHB_DX = "smsSender";
	private static final String SMSCOUNT = "SMSCOUNT";
	private static final String USERAVATAR = "userAvatar:";

	public CacheTool(String Hashkey, Class className){
		this.jedisKey = Hashkey;
		this.className = className;
//		this.jedis = BeanUtil.getBean("jedisClient",JedisClient.class);
	}

	public CacheTool(String Hashkey){
		this.jedisKey = Hashkey;
//		this.jedis = BeanUtil.getBean("jedisClient",JedisClient.class);
	}


	private static CacheTool storeTool = new CacheTool(CACHE_NAMESPACE + "S",ExStore.class);
	private static CacheTool expressTool = new CacheTool(CACHE_NAMESPACE + "E",ExExpressType.class);
//	private static CacheTool typeLibraryTool = new CacheTool(CACHE_NAMESPACE + "T", TypeLibrary.class);
	private static CacheTool userTool = new CacheTool(CACHE_NAMESPACE + "U", User.class);
	private static CacheTool storeShelfTool = new CacheTool(CACHE_NAMESPACE + "SS", StoreShelf.class);
	private static CacheTool shelfTool = new CacheTool(CACHE_NAMESPACE + "ST", StoreShelf.class);
	private static final String DELIVERY_STATUS = "delivery-status";
	//	private static CacheTool provinceTool = new CacheTool(CACHE_NAMESPACE + "P", Province.class);
//	private static CacheTool cityTool = new CacheTool(CACHE_NAMESPACE + "C", City.class);
//	private static CacheTool areaTool = new CacheTool(CACHE_NAMESPACE + "A", Area.class);
//	private static CacheTool menuTool = new CacheTool(CACHE_NAMESPACE+"M", Menu.class);
//	private static CacheTool phoneTool = new CacheTool(CACHE_NAMESPACE+"PHONE", PhoneLibDto.class);
	private static CacheTool configurationTool = new CacheTool(CACHE_NAMESPACE + "O",Configuration.class);
//	private static CacheTool limitTool = new CacheTool(CACHE_NAMESPACE + "LI",StoreReqLimit.class);
	private static CacheTool storeModelTool = new CacheTool(CACHE_NAMESPACE + "SMODEL",StoreTemplateDto.class);
	private static CacheTool smsFlagTool = new CacheTool(CACHB_DX );
	private static CacheTool smsCount = new CacheTool(SMSCOUNT + "SMSCOUNT",Long.class);
	private static CacheTool pubObject = new CacheTool("",Long.class);
	private static CacheTool platformConfigTool = new CacheTool(CACHE_NAMESPACE + "pfc",Platform.class);
//	private static CacheTool sendBackReasonTool = new CacheTool(CACHE_NAMESPACE+"SENDBR", SendBackReason.class);
    private static CacheTool deliveryStatusTool = new CacheTool(DELIVERY_STATUS);
	private static CacheTool sysTypeTool = new CacheTool(CACHE_NAMESPACE + "sysType", SysType.class);
	private static CacheTool sysParamTool = new CacheTool(CACHE_NAMESPACE + "sysParam", SysParam.class);
	private static CacheTool expressAccountTool = new CacheTool(CACHE_NAMESPACE + "EA", ExpressDeptAccount.class);
	private static CacheTool userAvatarTool = new CacheTool(USERAVATAR, String.class);

	public CacheTool(){

	}


	public static CacheTool initPubObject(){
		return pubObject;
	}
	public static CacheTool initSMSFlag(){
		return smsFlagTool;
	}
	public static CacheTool initStore() {
        return storeTool;
    }
	public static CacheTool initConfiguration() {
		return configurationTool;
	}
//	public static CacheTool initLimit() {
//		return limitTool;
//	}
	public static CacheTool initExpress(){
		 return expressTool;
	}
//	public static CacheTool initTypeLibrary(){
//		 return typeLibraryTool;
//	}
	public static CacheTool initUser(){
		 return userTool;
	}
	public static CacheTool initStoreShelf(){
		 return storeShelfTool;
	}
	public static CacheTool initShelf(){
		 return shelfTool;
	}
//	public static CacheTool initProvince(){
//		 return provinceTool;
//	}
//	public static CacheTool initCity(){
//		 return cityTool;
//	}
//	public static CacheTool initArea(){
//		 return areaTool;
//	}
//	public static CacheTool initMenu(){
//		return menuTool;
//	}
//	public static CacheTool initPhone(){
//		return phoneTool;
//	}
	public static CacheTool initStoreModel(){
		return storeModelTool;
	}
	public static CacheTool initSmsCount(){
		return smsCount;
	}
	public static CacheTool initPlatformConfig(){
		return platformConfigTool;
	}
	public static CacheTool initDeliveryStatusTool(){
		return deliveryStatusTool;
	}
	public static CacheTool initSysTypeTool(){
		return sysTypeTool;
	}
	public static CacheTool initSysParamTool(){
		return sysParamTool;
	}
//	public static CacheTool initSendBackReason(){
//	    return sendBackReasonTool;
//    }
	public static CacheTool initExpressAccountTool(){
		return expressAccountTool;
	}
	public static CacheTool initUserAvatarTool(){
		return userAvatarTool;
	}

	/**
	 * 根据key获取对象
	 */
	public Object getBean(String key ){
		if(null == jedis){
			WebApplicationContext wac = ContextLoader.getCurrentWebApplicationContext();
			jedis = BeanUtil.getBean("jedisClient",JedisClient.class);
		}
		String json = jedis.hget(this.jedisKey, key);
		if("0".equals(key)){
			//map or list
			return json;
		}else{
			return JSON.parseObject(json, this.className);
		}
	}

	/**
	 * 根据key获取对象
	 * @param <T>
	 */
	public <T> List<T> getBean(String key, Class<T> clazz){
		if(null == jedis){
			WebApplicationContext wac = ContextLoader.getCurrentWebApplicationContext();
			jedis = BeanUtil.getBean("jedisClient",JedisClient.class);
		}
		String json = jedis.hget(this.jedisKey, key);
		return JSON.parseArray(json, clazz);

	}



	/**
	 * 保存被序列化后的对象
	 */
	public boolean saveBean(String key, Object value){
		long ret = -1;
		if(null == jedis){
			WebApplicationContext wac = ContextLoader.getCurrentWebApplicationContext();
			jedis = BeanUtil.getBean("jedisClient",JedisClient.class);
		}

		if(null == value){
			//删除操作
			ret = jedis.hdel(this.jedisKey, key);
		}
		else{
			String json = JSON.toJSONString(value);
			ret = jedis.hset(this.jedisKey, key, json);
		}

		return ret == 0 ? true: false;
	}

	/**
	 * 根据key获取String
	 */
	public String getString(String key ){
		if(null == jedis){
			WebApplicationContext wac = ContextLoader.getCurrentWebApplicationContext();
			jedis = BeanUtil.getBean("jedisClient",JedisClient.class);
		}
		return jedis.hget(this.jedisKey, key);
	}

	/**
	 * 根据key设置过期时间
	 */
	public boolean setExpire(String key,Integer Timestamp){
		if(null == jedis){
			WebApplicationContext wac = ContextLoader.getCurrentWebApplicationContext();
			jedis = BeanUtil.getBean("jedisClient",JedisClient.class);
		}
		String string = getString(key);

		long expire = jedis.expire(key,Timestamp);
		return expire > 0 ? true:false;
	}

    /**
     * 根据key获取对象String
     */
    public String getStringKey(String key){
        if(null == jedis){
            WebApplicationContext wac = ContextLoader.getCurrentWebApplicationContext();
            jedis = BeanUtil.getBean("jedisClient",JedisClient.class);
        }
        return jedis.get(this.jedisKey+":"+key);
    }

    /**
     * set对象String并获取过期时间
     */
    public void setStringandDatakey(String key,String value,Integer dataTime){
        long ret = -1;
        if(null == jedis){
            WebApplicationContext wac = ContextLoader.getCurrentWebApplicationContext();
            jedis = BeanUtil.getBean("jedisClient",JedisClient.class);
        }
        jedis.set(this.jedisKey+":"+key, value, dataTime);
    }

    /**
     * set对象Sting
     */
    public void setStringKey(String key,String value){
        long ret = -1;
        if(null == jedis){
            WebApplicationContext wac = ContextLoader.getCurrentWebApplicationContext();
            jedis = BeanUtil.getBean("jedisClient",JedisClient.class);
        }
        jedis.set(this.jedisKey+":"+key, value);
    }

	/**
	 * 获取所有key
	 * @return
	 */
	public Set<byte[]> getKeys(){
		if(null == jedis){
			WebApplicationContext wac = ContextLoader.getCurrentWebApplicationContext();
			jedis = BeanUtil.getBean("jedisClient",JedisClient.class);
		}
		return jedis.keys(this.jedisKey+"*");
	}

	/**
	 * 根据key删除数据
	 * @return
	 */
	public void del(String key){
		if(null == jedis){
			WebApplicationContext wac = ContextLoader.getCurrentWebApplicationContext();
			jedis = BeanUtil.getBean("jedisClient",JedisClient.class);
		}
		jedis.del(this.jedisKey+":"+key);
	}
	/**
	 * 根据key删除数据
	 * @return
	 */
	public void hdel(String key){
		if(null == jedis){
			WebApplicationContext wac = ContextLoader.getCurrentWebApplicationContext();
			jedis = BeanUtil.getBean("jedisClient",JedisClient.class);
		}
		jedis.hdel(this.jedisKey,key);
	}

}
