package cn.bs.bsmanagebasic.controller;

import cn.bs.bsmanagebasic.common.util.Pager;
import cn.bs.bsmanagebasic.entity.dto.AdminUserEditDto;
import cn.bs.bsmanagebasic.entity.dto.AdminUserListDto;
import cn.bs.bsmanagebasic.entity.user.AdminUser;
import cn.bs.bsmanagebasic.service.AdminUserService;
import cn.bs.bsmanagecommon.result.ResultBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;

/**
 * @description: 管理员管理
 * @author: chenxuebing
 * @create: 2021-04-30 16:43
 **/
@RestController
public class AdmnUserController {

    @Autowired
    private AdminUserService adminUserService;

    /**
     * 根据类型(AdminTypeEnum)查询用户列表
     * @param adminUserListDto
     * @return
     */
    @GetMapping(value ="/adminUser/list")
    public ResultBean<Pager<AdminUser>> listAdminUser(HttpServletRequest request, AdminUserListDto adminUserListDto){
        return new ResultBean<Pager<AdminUser>>(adminUserService.listAdminUser(request, adminUserListDto));
    }

    /**
     * 根据类型(AdminTypeEnum)添加用户
     * @param adminUserEditDto
     * @return
     */
    @PostMapping(value ="/adminUser/add")
    public ResultBean<Pager<AdminUser>> addAdminUser(HttpServletRequest request, @RequestBody AdminUserEditDto adminUserEditDto){
        return new ResultBean(adminUserService.addAdminUser(request, adminUserEditDto));
    }
    /**
     * 根据类型(AdminTypeEnum)修改用户
     * @param adminUserEditDto
     * @return
     */
    @PostMapping(value ="/adminUser/update")
    public ResultBean<Pager<AdminUser>> updateAdminUser(HttpServletRequest request, @RequestBody AdminUserEditDto adminUserEditDto){
        return new ResultBean(adminUserService.updateAdminUser(request, adminUserEditDto));
    }
    /**
     * 根据类型(AdminTypeEnum)获取用户
     * @param userId
     * @return
     */
    @GetMapping(value ="/adminUser/get")
    public ResultBean<AdminUser> getAdminUser(HttpServletRequest request, String userId){
        return new ResultBean(adminUserService.getAdminUser(request, userId));
    }
    /**
     * 根据类型(AdminTypeEnum)删除用户
     * @param userId
     * @return
     */
    @GetMapping(value ="/adminUser/delete")
    public ResultBean deleteAdminUser(HttpServletRequest request, String userId){
        return new ResultBean(adminUserService.deleteAdminUser(request, userId));
    }
}
