package cn.bs.bsmanagebasic.controller;

import cn.bs.bsmanagebasic.entity.TBsCompany;
import cn.bs.bsmanagebasic.service.CompanyService;
import cn.bs.bsmanagecommon.result.ResultBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * @author sunjj
 * @version 1.0.0
 * @ClassName CompanyController.java
 * @Description 公司信息Controller
 * @createTime 2019年07月23日 13:07:00
 */
@RestController
@RequestMapping("/company")
@CrossOrigin(allowCredentials ="true")
public class CompanyController {
    @Autowired
    private CompanyService companyService;


    /**
     * @description 获取公司信息
     * @author sunjj
     */
    @GetMapping("/getCompanies")
    public ResultBean<List<TBsCompany>> getCompanies() {
        return new ResultBean<List<TBsCompany>>(companyService.getAll());
    }

}
