package cn.bs.bsmanagebasic.controller;

import cn.bs.bsmanagebasic.entity.Configuration;
import cn.bs.bsmanagebasic.entity.PickupQueue;
import cn.bs.bsmanagebasic.entity.Platform;
import cn.bs.bsmanagebasic.service.ConfigurationService;
import cn.bs.bsmanagebasic.service.PlatformService;
import cn.bs.bsmanagecommon.requst.RequestBean;
import cn.bs.bsmanagecommon.result.ResultBean;
import com.alibaba.fastjson.JSON;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 〈功能概述〉<br>
 *
 * @className: ConfigurationController
 * @package: cn.bs.bsmanagebasic.controller
 * @author: kael
 * @date: 2019/11/26 0026 下午 15:41
 */
@RestController
@RequestMapping("/config")
@CrossOrigin(allowCredentials ="true")
public class ConfigurationController {

    @Autowired
    private ConfigurationService configurationService;

    @Autowired
    private PlatformService platformService;

    /**
     * 获取列表
     * @param data
     * @return
     */
    @RequestMapping(value ="/list", method = {RequestMethod.GET})
    public ResultBean<List<Configuration>> list(){
        return new ResultBean<>(configurationService.getList());
    }

    /**
     * 保存
     * @param data
     * @return
     */
    @RequestMapping(value ="/save", method = {RequestMethod.POST})
    public ResultBean<Boolean> save(@RequestBody String data){
        return new ResultBean<Boolean>(configurationService.save(JSON.parseObject(JSON.parseObject(data, RequestBean.class).getData(), Configuration.class)));
    }

    /**
     * 通过id删除单条数据
     *
     * @param data
     * @return
     */
    @RequestMapping(value = "/delete", method = {RequestMethod.POST})
    public ResultBean<Boolean> deleteById(@RequestBody String data) {
        return new ResultBean<Boolean>(configurationService.deleteById(JSON.parseObject(JSON.parseObject(data, RequestBean.class).getData(), Configuration.class)));
    }

    /**
     * 获取平台配置列表
     * @param data
     * @return
     */
    @RequestMapping(value ="/platform/list", method = {RequestMethod.GET})
    public ResultBean<List<Platform>> platformList(){
        return new ResultBean<>(platformService.getAll());
    }

    /**
     * 保存
     * @param data
     * @return
     */
    @RequestMapping(value ="/platform/save", method = {RequestMethod.POST})
    public ResultBean<Boolean> platformSave(@RequestBody String data){
        return new ResultBean<Boolean>(platformService.save(JSON.parseObject(JSON.parseObject(data, RequestBean.class).getData(), Platform.class)));
    }

    /**
     * 通过id删除单条数据
     *
     * @param data
     * @return
     */
    @RequestMapping(value = "/platform/delete", method = {RequestMethod.POST})
    public ResultBean<Boolean> platformDeleteById(@RequestBody String data) {
        return new ResultBean<Boolean>(platformService.deleteById(JSON.parseObject(JSON.parseObject(data, RequestBean.class).getData(), Platform.class)));
    }
}
