package cn.bs.bsmanagebasic.controller;
import cn.bs.bsmanagebasic.entity.filter.DeliveryFilter;
import cn.bs.bsmanagebasic.common.util.Pager;
import cn.bs.bsmanagebasic.entity.bases.BatchDataMsg;
import cn.bs.bsmanagebasic.entity.delivery.Delivery;
import cn.bs.bsmanagebasic.service.DeliveryService;
import cn.bs.bsmanagecommon.requst.RequestBean;
import cn.bs.bsmanagecommon.result.ResultBean;
import com.alibaba.fastjson.JSON;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * 订单业务<br>
 *
 * @className: DeliveryController
 * @package: cn.bs.bsmanagebasic.controller
 * @author: kael
 * @date: 2019/11/11 0011 上午 11:06
 */
@RestController
@RequestMapping("/delivery")
@CrossOrigin(allowCredentials ="true")
public class DeliveryController {

    @Autowired
    private DeliveryService deliveryService;

    /**
     * 新增
     * @param data
     * @return
     */
    @RequestMapping(value ="/sign", method = {RequestMethod.POST})
    public ResultBean<List<BatchDataMsg>> sign(@RequestBody String data){
        return new ResultBean<>(deliveryService.sign(JSON.parseObject(JSON.parseObject(data, RequestBean.class).getData(),DeliveryFilter.class)));
    }

    @PostMapping("/query")
    public ResultBean<Pager<Delivery>> query(@RequestBody String data, HttpServletRequest request){
        return new ResultBean<>(deliveryService.queryDeliverys(JSON.parseObject(JSON.parseObject(data, RequestBean.class).getData(), DeliveryFilter.class), request));
    }
	
	/**
     * 获取订单数据
     * @param data
     * @return
     */
    @RequestMapping(value ="/list", method = {RequestMethod.POST})
    public ResultBean<Pager<Delivery>> list(@RequestBody String data, HttpServletRequest request){
        return new ResultBean<>(deliveryService.list(JSON.parseObject(JSON.parseObject(data, RequestBean.class).getData(), DeliveryFilter.class), request));
    }

    /**
     * 修改快递状态
     * @param data
     * @return
     */
    @RequestMapping(value ="/updateExpStatus",method = {RequestMethod.POST})
    public ResultBean<List<BatchDataMsg>> updateExpStatus(@RequestBody String data){
        return new ResultBean<>(deliveryService.updateExpStatus(JSON.parseObject(JSON.parseObject(data,RequestBean.class).getData(),DeliveryFilter.class)));
    }

    /**
     * 根据城市Id获取地区列表
     */
    @GetMapping(value = {"/getPickupCodeByPhone/{phone}", "/getDistricts"})
    public ResultBean<List<String>> getPickupCodeByPhone(@PathVariable(required = false) String phone) {
        return new ResultBean<List<String>>(deliveryService.getPickupCodeByPhone(phone));
    }
}
