package cn.bs.bsmanagebasic.controller;

import cn.bs.bsmanagebasic.entity.ExExpressType;
import cn.bs.bsmanagebasic.service.ExpressService;
import cn.bs.bsmanagecommon.result.ResultBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * @author sunjj
 * @version 1.0.0
 * @ClassName ExpressController.java
 * @Description 快递公司
 * @createTime 2019年07月23日 15:42:00
 */

@RestController
@RequestMapping("/express")
@CrossOrigin(allowCredentials ="true")
public class ExpressController {

    @Autowired
    private ExpressService expressService;

    /**
     * @throws
     * @description 获取可以签收回传的快递公司
     * @author sunjj
     */
    @GetMapping("/getExpressWithSignBack")
    public ResultBean<List<ExExpressType>> getExpressWithSignBack() {
        return new ResultBean<>(expressService.getExpressWithSignBack());
    }

    /**
     * 获取所有的快递公司
     * @return
     */
    @GetMapping("/getAllExpress")
    public ResultBean<List<ExExpressType>> getAllExpress() {
        return new ResultBean<>(expressService.getAllExpress());
    }

}
