package cn.bs.bsmanagebasic.controller;

import cn.bs.bsmanagebasic.entity.Menu;
import cn.bs.bsmanagebasic.entity.MenuRouter;
import cn.bs.bsmanagebasic.service.MenuService;
import cn.bs.bsmanagecommon.result.ResultBean;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * @author LiuJS
 * @Time 2021/4/26 16:19
 * @Desc 菜单管理
 * @Version 1.0
 */
@RestController
@RequestMapping("menu")
public class MenuController {
    @Resource
    private MenuService menuService;

    /**
     * 获取菜单列表
     * @return
     */
    @GetMapping("list")
    public ResultBean<List<Menu>> listMenu(){
        return new ResultBean(menuService.list());
    }

    @PostMapping("add")
    public ResultBean addResource(@RequestBody Menu menu) {
        return new ResultBean(menuService.addMenu(menu));
    }

    @PostMapping("update")
    public ResultBean updateResource(@RequestBody Menu menu) {
        return new ResultBean(menuService.updateMenu(menu));
    }

    @GetMapping("delete")
    public ResultBean deleteResource(Long id) {
        return new ResultBean(menuService.deleteMenu(id));
    }

    /**
     * 当前用户所拥有菜单
     * @param request
     * @return
     */
    @GetMapping("roleMenu/all")
    public ResultBean listMenuAll(HttpServletRequest request) {
        return new ResultBean(menuService.listMenuAll(request));
    }

    /**
     * 菜单路由
     * @param request
     * @return
     */
    @GetMapping("role_router")
    public ResultBean<List<MenuRouter>> getRoleRouter(HttpServletRequest request) {
        return new ResultBean<>(menuService.getRoleRouter(request));
    }

    /**
     * 按钮权限
     * @param request
     * @return
     */
    @GetMapping("get_api_permission")
    public ResultBean<List<String>> getApiPermission(HttpServletRequest request) {
        return new ResultBean<>(menuService.getApiPermission(request));
    }
}
