package cn.bs.bsmanagebasic.controller;
import cn.bs.bsmanagebasic.entity.TempNotice;
import cn.bs.bsmanagebasic.entity.filter.NoticeFilter;
import cn.bs.bsmanagebasic.service.NoticeService;
import cn.bs.bsmanagecommon.requst.RequestBean;
import cn.bs.bsmanagecommon.result.ResultBean;
import com.alibaba.fastjson.JSON;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * @author liujs
 * @version 1.0.0
 * @ClassName NoticeController
 * @Description 公告业务
 * @createTime 2019年11月26日 15:42:00
 */
@RestController
@RequestMapping("/notice")
@CrossOrigin(allowCredentials ="true")
public class NoticeController {

    @Autowired
    private NoticeService noticeService;

    /**
     * 增加公告
     * @param data
     * @return
     */
    @RequestMapping(value = "/add",method = RequestMethod.POST)
    public ResultBean<Boolean> addNotice(@RequestBody String data){
        return new ResultBean<>(noticeService.addNotice(JSON.parseObject(JSON.parseObject(data,RequestBean.class).getData(), TempNotice.class)));
    }

    /**
     * 发送公告
     * @param data
     * @return
     */
    @RequestMapping(value = "/send",method = RequestMethod.POST)
    public ResultBean<Boolean> sendNotice(@RequestBody String data){
        return new ResultBean<>(noticeService.sendNotice(JSON.parseObject(JSON.parseObject(data, RequestBean.class).getData(), NoticeFilter.class)));
    }
}
