package cn.bs.bsmanagebasic.controller;

import cn.bs.bsmanagebasic.entity.Platform;
import cn.bs.bsmanagebasic.service.PlatformService;
import cn.bs.bsmanagecommon.result.ResultBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * 平台<br>
 *
 * @className: PlatformController
 * @package: cn.bs.bsmanagebasic.controller
 * @author: kael
 * @date: 2019/10/29 0029 下午 15:12
 */
@RestController
@RequestMapping("/platform")
@CrossOrigin(allowCredentials ="true")
public class PlatformController {

    @Autowired
    private PlatformService platformService;

    /**
     * @description 获取可以签收回传的快递公司
     * @author sunjj
     * @throws
     */
    @GetMapping("/getAll")
    public ResultBean<List<Platform>> getAll(){
        return new ResultBean<List<Platform>>(platformService.getAll());
    }
}
