package cn.bs.bsmanagebasic.controller;

import cn.bs.bsmanagebasic.common.util.Pager;
import cn.bs.bsmanagebasic.entity.SmsRecord;
import cn.bs.bsmanagebasic.entity.TempNotice;
import cn.bs.bsmanagebasic.entity.filter.NoticeFilter;
import cn.bs.bsmanagebasic.entity.filter.SmsRecordFilter;
import cn.bs.bsmanagebasic.service.SmsService;
import cn.bs.bsmanagecommon.requst.RequestBean;
import cn.bs.bsmanagecommon.result.ResultBean;
import com.alibaba.fastjson.JSON;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;

/**
 * 〈功能概述〉<br>
 *
 * @className: SmsController
 * @package: cn.bs.bsmanagebasic.controller
 * @author: Administrator
 * @date: 2019/10/16 0016 下午 16:07
 */
@RestController
@RequestMapping("/sms")
@CrossOrigin(allowCredentials ="true")
public class SmsController {

    @Autowired
    private SmsService smsService;

    @RequestMapping(value ="/resendSms", method = {RequestMethod.POST})
    public ResultBean<Boolean> resendSms(@RequestBody String data){
        return new ResultBean<Boolean>(smsService.resendSms(JSON.parseObject(JSON.parseObject(data,RequestBean.class).getData(), SmsRecordFilter.class)));
    }

    @RequestMapping(value ="/getSmsRecord", method = {RequestMethod.POST})
    public ResultBean<Pager<SmsRecord>> getSmsRecord(@RequestBody String data, HttpServletRequest request){
        return new ResultBean<Pager<SmsRecord>>(smsService.getList(JSON.parseObject(JSON.parseObject(data,RequestBean.class).getData(), SmsRecordFilter.class), request));
    }

    @RequestMapping(value ="/getSmsRecordCount", method = {RequestMethod.POST})
    public ResultBean<Integer> getSmsRecordCount(@RequestBody String data){
        return new ResultBean<Integer>(smsService.getCount(JSON.parseObject(JSON.parseObject(data,RequestBean.class).getData(), SmsRecordFilter.class)));
    }

    @RequestMapping(value ="/saveNotice", method = {RequestMethod.POST})
    public ResultBean<Boolean> saveNotice(@RequestBody String data){
        return new ResultBean<Boolean>(smsService.saveNotice(JSON.parseObject(JSON.parseObject(data,RequestBean.class).getData(), TempNotice.class)));
    }

    @RequestMapping(value ="/getNotice", method = {RequestMethod.POST})
    public ResultBean<Pager<TempNotice>> getNotice(@RequestBody String data){
        return new ResultBean<Pager<TempNotice>>(smsService.getNotice(JSON.parseObject(JSON.parseObject(data,RequestBean.class).getData(), NoticeFilter.class)));
    }

    @RequestMapping(value ="/deleteNotice", method = {RequestMethod.POST})
    public ResultBean<Boolean> deleteNotice(@RequestBody String data){
        return new ResultBean<Boolean>(smsService.deleteNotice(JSON.parseArray(JSON.parseObject(data,RequestBean.class).getData(),Integer.class)));
    }
}
