package cn.bs.bsmanagebasic.controller;

import cn.bs.bsmanagebasic.entity.dto.StatisticsReportDto;
import cn.bs.bsmanagebasic.entity.filter.StatisticsReportFilter;
import cn.bs.bsmanagebasic.service.StatisticsReportService;
import cn.bs.bsmanagecommon.result.ResultBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;


/**
 *Time: 2021/5/13 14:35                                       
 * Author: zhangHP
 * @description:统计
 */
@RestController
@RequestMapping("/statistics")
@CrossOrigin(allowCredentials ="true")
public class StatisticsReportController {

    @Autowired
    private StatisticsReportService statisticsService;

    /**
     * 根据快递公司进行统计 入库
     * @param filter
     * @return
     */
    @RequestMapping(value ="/expCompany",method = {RequestMethod.POST})
    public ResultBean<List<StatisticsReportDto>> countGroupByCompany( StatisticsReportFilter filter){
        return new ResultBean<>(statisticsService.countGroupByCompany(filter));
    }

    /**
     *根据门店进行统计 入库
     * @param filter
     * @return
     */
    @RequestMapping(value ="/store",method = {RequestMethod.POST})
    public ResultBean<List<StatisticsReportDto>> countGroupByStore( StatisticsReportFilter filter){
        return new ResultBean<>(statisticsService.countGroupByStore(filter));
    }

    /**
     * 根据外派员统计 入库
     * @param filter
     * @return
     */
    @RequestMapping(value ="/storeStaff",method = {RequestMethod.POST})
    public ResultBean<List<StatisticsReportDto>> countGroupByStoreStaff( StatisticsReportFilter filter){
        return new ResultBean<>(statisticsService.countGroupByStoreStaff(filter));
    }


}
