package cn.bs.bsmanagebasic.controller;

import cn.bs.bsmanagebasic.common.util.Pager;
import cn.bs.bsmanagebasic.entity.ExStore;
import cn.bs.bsmanagebasic.entity.dto.StoreDto;
import cn.bs.bsmanagebasic.service.StoreManageService;
import cn.bs.bsmanagecommon.requst.RequestBean;
import cn.bs.bsmanagecommon.result.ResultBean;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.math.BigDecimal;
import java.util.List;

@RestController
@RequestMapping("/store")
@CrossOrigin(allowCredentials ="true")
public class StoreManageController {

    @Autowired
    private StoreManageService exStoreService;

    /**
     * @throws
     * @title
     * @description
     * @author sunjj
     * @updateTime
     */
    @PostMapping("/addStore")
    public ResultBean addStore(@RequestBody String data) {
        RequestBean requestBean = JSON.parseObject(data, RequestBean.class);
        return new ResultBean<Boolean>(exStoreService.addStore(requestBean.getData()));
    }

    @PostMapping("/getList")
    public ResultBean<Pager<StoreDto>> getList(@RequestBody String data, HttpServletRequest request) {
        RequestBean requestBean = JSON.parseObject(data, RequestBean.class);
        StoreDto dto = JSON.parseObject(requestBean.getData(), StoreDto.class);
        return new ResultBean<Pager<StoreDto>>(exStoreService.getListByParam(dto, request));
    }

    @GetMapping("/getListStore")
    public ResultBean<List<ExStore>> getListStore() {
        return new ResultBean<List<ExStore>>(exStoreService.getListStore());
    }

    @PostMapping("/editInfo")
    public ResultBean<Boolean> editInfo(@RequestBody String data){
        RequestBean requestBean = JSON.parseObject(data, RequestBean.class);
        StoreDto dto = JSON.parseObject(requestBean.getData(), StoreDto.class);
        return new ResultBean<Boolean>(exStoreService.editInfo(dto));
    }

    @PostMapping("/money")
    public ResultBean<Boolean> money(@RequestBody String data){
        RequestBean requestBean = JSON.parseObject(data, RequestBean.class);
        JSONObject jsonObject = JSON.parseObject(requestBean.getData());
        BigDecimal money = jsonObject.getBigDecimal("money");
        Long id = jsonObject.getLong("id");
        return new ResultBean<Boolean>(exStoreService.money(id, money));
    }

    @PostMapping("/disable")
    public ResultBean<Boolean> disable(@RequestBody String data){
        RequestBean requestBean = JSON.parseObject(data, RequestBean.class);
        StoreDto dto = JSON.parseObject(requestBean.getData(), StoreDto.class);
        return new ResultBean<Boolean>(exStoreService.disable(dto));
    }
	
	@PostMapping("/getStoreById")
    public ResultBean<StoreDto> getStoreById(@RequestBody String data)  throws Exception{
        RequestBean requestBean = JSON.parseObject(data, RequestBean.class);
        StoreDto dto = JSON.parseObject(requestBean.getData(), StoreDto.class);
        return new ResultBean<StoreDto>(exStoreService.getStoreById(dto));
    }
}



