package cn.bs.bsmanagebasic.controller;

import cn.bs.bsmanagebasic.entity.filter.UserFilter;
import cn.bs.bsmanagebasic.entity.user.LoginData;
import cn.bs.bsmanagebasic.service.UserService;
import cn.bs.bsmanagecommon.requst.RequestBean;
import cn.bs.bsmanagecommon.result.ResultBean;
import com.alibaba.fastjson.JSON;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
 * 〈功能概述〉<br>
 *
 * @className: LoginController
 * @package: cn.bs.bsmanagebasic.controller
 * @author: kael
 * @date: 2019/12/20 0020 下午 14:17
 */
@RestController
@RequestMapping("/user")
@CrossOrigin(allowCredentials ="true")
public class UserController {

    @Autowired
    private UserService userService;

    /**
     * 用户登录
     * @param data
     * @return
     */
    @RequestMapping(value ="/login", method = {RequestMethod.POST})
    @ResponseBody
    public ResultBean<LoginData> querySignReturn(@RequestBody String data){
        return new ResultBean<LoginData>(userService.login(JSON.parseObject(data, UserFilter.class)));
    }

    /**
     *
     * @return
     */
    @GetMapping("/info")
    public ResultBean<Map> info() {
        return new ResultBean<Map>(userService.getRole());
    }

    /**
     * 退出登录
     * @return
     */
    @GetMapping("/logout")
    public ResultBean<Boolean> logout() {
        return new ResultBean<Boolean>(userService.logout());
    }

    /**
     * 更新头像
     * @param data
     * @return
     */
    @RequestMapping(value ="/updateUserAvatar", method = {RequestMethod.POST})
    @ResponseBody
    public ResultBean<Boolean> updateUserAvatar(@RequestBody String data){
        return new ResultBean<Boolean>(userService.updateUserAvatar(JSON.parseObject(JSON.parseObject(data, RequestBean.class).getData(), UserFilter.class)));
    }

    /**
     * 修改密码
     * @param data
     * @return
     */
    @RequestMapping(value ="/updateUserPassword", method = {RequestMethod.POST})
    @ResponseBody
    public ResultBean<Boolean> updateUserPassword(@RequestBody String data){
        return new ResultBean<Boolean>(userService.updateUserPassword(JSON.parseObject(JSON.parseObject(data, RequestBean.class).getData(), UserFilter.class)));
    }
}
