package cn.bs.bsmanagebasic.dao.jisu;

import cn.bs.bsmanagebasic.entity.User;
import cn.bs.bsmanagebasic.entity.dto.StoreStaffDto;
import cn.bs.bsmanagebasic.entity.filter.StoreStaffFilter;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 门店外派员信息
 */
@Mapper
public interface StoreStaffMapper {

    /**
     * 获取外派员信息列表
     * @param storeId
     * @return
     */
    List<StoreStaffDto> getStoreStaffList(@Param("storeId") Long storeId);

    /**
     * 新增外派员
     * @param user
     * @return
     */
    boolean addStoreStaff(@Param("storeStaff") User user);

    /**
     * 修改
     * @param storeStaff
     * @return
     */
    boolean updateStoreStaffById(User storeStaff);

    /**
     * 删除
     * @param userId
     * @return
     */
    boolean deleteStoreStaffById(String userId);


    /**
     * 查询
     * @param storeStaff
     * @return
     */
    List<StoreStaffDto> queryStoreStaff(StoreStaffFilter storeStaff);

    /**
     * 条数
     * @param filter
     * @return
     */
    Integer listCount(StoreStaffFilter filter);

    /**
     * 详情
     * @param userId
     * @return
     */
    StoreStaffDto detailStaff(String userId);

    List<StoreStaffDto> getStoreStaffPage(StoreStaffFilter filter);
}
