package cn.bs.bsmanagebasic.dao.jisu;

import java.util.List;

import cn.bs.bsmanagebasic.entity.User;
import cn.bs.bsmanagebasic.entity.UserExample;
import cn.bs.bsmanagebasic.entity.dto.AdminUserListDto;
import cn.bs.bsmanagebasic.entity.user.AdminUser;
import cn.bs.bsmanagebasic.entity.user.UserRole;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

@Repository
public interface UserMapper {
    long countByExample(UserExample example);

    int deleteByExample(UserExample example);

    int deleteByPrimaryKey(String userId);

    int insert(User record);

    int insertSelective(User record);

    List<User> selectByExample(UserExample example);

    User selectByPrimaryKey(String userId);

    int updateByExampleSelective(@Param("record") User record, @Param("example") UserExample example);

    int updateByExample(@Param("record") User record, @Param("example") UserExample example);

    int updateByPrimaryKeySelective(User record);

    int updateByPrimaryKey(User record);

    /**
     * 添加用户角色
     * @param userRole
     * @return
     */
    int addUserRole(UserRole userRole);

    /**
     * 根据用户类型查询用户总条数 AdminTypEnum
     * @param adminUserListDto
     * @return
     */
    int getAdminUserCount(AdminUserListDto adminUserListDto);

    /**
     * 根据用户类型查询用户 AdminTypEnum
     * @param adminUserListDto
     * @return
     */
    List<AdminUser> listAdminUser(AdminUserListDto adminUserListDto);
}