package cn.bs.bsmanagebasic.entity.amap;

import lombok.Data;

import java.util.List;

/**
 * @ClassName GeoCodeResponse
 * @Description
 * @Author SunJJ
 * @Date 2020/7/8 10:44
 * @Version V1.0
 **/
@Data
public class GeoCodeResponse {
    /**
     * 返回结果状态值
     * 返回值为 0 或 1，0 表示请求失败；1 表示请求成功。
     */
    private Integer status;
    
    /**
     * 返回状态说明
     * 当 status 为 0 时，info 会返回具体错误原因，否则返回“OK”。详情可以参考info状态表
     */
    private String info;

    /**
     * 逆地理编码列表
     * batch 字段设置为 true 时为批量请求，此时 regeocodes 标签返回，标签下为 regeocode 对象列表；batch 为false 时为单个请求，会返回 regeocode 对象；
     */
    private List<Regeocode> geocodes;


}
