package cn.bs.bsmanagebasic.entity.amap;

import lombok.Data;

/**
 * @ClassName Regeocode
 * @Description
 * @Author SunJJ
 * @Date 2020/7/8 10:47
 * @Version V1.0
 **/
@Data
public class Regeocode {
    /**
     * 结构化地址信息
     * 结构化地址信息包括：省份＋城市＋区县＋城镇＋乡村＋街道＋门牌号码
     * 如果坐标点处于海域范围内，则结构化地址信息为：省份＋城市＋区县＋海域信息
     */
    private String formatted_address;

    /**
     * 国家
     * 国内地址默认返回中国
     */
    private String country;

    /**
     * 地址所在的省份名
     * 例如：北京市。此处需要注意的是，中国的四大直辖市也算作省级单位。
     */
    private String province;

    /**
     * 地址所在的城市名
     * 例如：北京市
     */
    private String city;

    /**
     * 城市编码
     * 例如：010
     */
    private String citycode;

    /**
     * 地址所在的区
     * 例如：朝阳区
     */
    private String district;

    /**
     * 街道
     * 例如：阜通东大街
     */
    private String street;

    /**
     * 门牌
     * 例如：6号
     */
    private String number;

    /**
     * 区域编码
     * 例如：110101
     */
    private String adcode;

    /**
     * 坐标点
     * 经度，纬度
     */
    private String location;

    /**
     * 匹配级别
     * 参见https://lbs.amap.com/api/webservice/guide/api/georegeo下方的地理编码匹配级别列表
     */
    private String level;

}
