package cn.bs.bsmanagebasic.entity.dto;

import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * @author sunjj
 * @version 1.0.0
 * @ClassName StoreDto.java
 * @Description 门店form表单对应DTO
 * @createTime 2019年07月23日 17:58:00
 */
@Data
public class StoreDto {

    private Long id;

    // 门店名称
    private String name;

    // 站点负责人
    private String owner;

    private String phone; // 负责人手机

    private String takeExpressPhone; // 客服电话

    private Long provinceId; //省

    private Long cityId; // 市

    private Long areaId; // 区

    private String address; // 联系地址

    private String shortAddress; // 取件地址

    private String startTime; // 营业开始时间

    private String endTime; // 营业结束时间

    private Integer status; // 使用状态

    private String appid; // 微信公众号ID appd

    private String appsecret; // 公众号开发者秘钥

    private String msgtempid; // 公众号到件通知模板ID

    private String signtempid;// 公众号签收通知模板ID

    private Integer auditStatus; // 审核状态

    private Integer companyId; // 所属公司

    private Integer storeType; // 门店类型

    private Long rent; // 租金

    private Date leaseStartDate; // 租赁日期（开始）

    private Date leaseEndDate; // 租赁日期（结束）

    private Long contractFee; // 承包费用

    private Date contractStartDate; // 承包日期(开始)

    private Date contractEndDate; // 承包日期(结束)

    private String ownerID; // 负责人身份证

    private String ownerAlipayAccount; // 负责人支付宝

    private String appOrderLink; // 公众号下单链接

    private String ownerWechat; // 负责人微信

    private String userId; // 门店账号

    private Integer smsSendType; // 推送机制

    private BigDecimal smsPrice; // 消息费率

    private BigDecimal smsBalance; // 账户余额

    private String comSign; // 短信标签

    private String usermail; // 邮箱

    private Long templateId;// 模板id

    private String siduanma; // 四段码

    private Integer reminder; //通知类型

    private List<Integer> signBackSwitch; // 签收回传的公司


    /** 门店类型名称 */
    private String storeTypeName;
    /** 门店所属公司名称*/
    private String companyName;
    /** 省名称*/
    private String provinceName;
    /** 市名称*/
    private String cityName;
    /** 地区名称*/
    private String areaName;

    /** 每页显示的条目数*/
    private int pageSize;
    /** 当前页码*/
    private int pageNumber;
    /** 查询开始*/
    private int begin;
    /** 门店状态名称*/
    private String statusName;
    /** 通知类型*/
    private String reminderName;
	
	private String regionCode;

	private Boolean upExpPhone;

	private Integer shelfCount;

	private Integer shelfLayers;
}
