package cn.bs.bsmanagebasic.entity.oss;

import lombok.Data;

import java.util.List;

/**
 * @packageName: cn.bs.bsmanagebasic.entity.oss
 * @className: bs-manage
 * @description: TODO
 * @author: liujs
 * @date: 2019/12/16 0016 下午 14:45
 * @version: 1.0
 */
@Data
public class BucketFilter{
    /**
     * 存储空间名称
     */
    private String bucketName;
    /**
     * 存储类型(默认是标准类型)
     * 有三种类型:标准存储类型(Standard);低频存储类型(IA);归档存储类型(Archive)
     * 对应的值:Standard;IA;Archive
     */
    private String storageType;
    /**
     * 数据容灾类型(默认情况下,本地冗余存储，即DataRedundancyType.LRS)
     * 有两种类型:本地冗余存储(LRS);同城冗余存储(ZRS)
     * 对应的值:LRS;ZRS
     */
    private String dataRedundancyType;
    /**
     * 您可以在创建存储空间（Bucket）时设置存储空间的访问权限（ACL），也可以在创建Bucket后根据自己的业务需求修改存储空间的ACL，该操作只有存储空间的拥有者可以执行
     * 存储空间的权限
     * 有四种权限:
     * 继承Bucket(Default)-->遵循存储空间的访问权限
     * 公共读写(PublicReadWrite)-->任何人（包括匿名访问者）都可以对该存储空间内文件进行读写操作
     * 公共读(PublicRead):只有该存储空间的拥有者可以对该存储空间内的文件进行写操作，任何人（包括匿名访问者）都可以对该存储空间中的文件进行读操作
     * 私有(Private):只有该存储空间的拥有者可以对该存储空间内的文件进行读写操作，其他人无法访问该存储空间内的文件
     * 对应的值:Default,Private,PublicRead,PublicReadWrite
     */
    private String cannedAccessControlList;
    /**
     * 0:列举所有的存储空间;  1:列举指定前缀的存储空间;  2:列举指定marker之后的存储空间
     * 3:列举指定个数的存储空间
     */
    private Integer selectBucketType;
    /**
     * 查询存储空间的参数
     */
    private String selectBucketParam;
    /**
     * 本地文件上传时需要定义什么自己想要的文件名称(对象名称)
     * 本地下载文件时 存储空间中的文件名称(即想下载的文件名称)
     */
    private String objectName;
    /**
     * 本地文件上传时文件名(路径+文件名称)
     * 本地文件下载时需要把文件放在哪个路径叫什么名称
     * 前端上传文件时 可以截取默认文件名
     */
    private String filePath;
    /**
     * 批量删除文件(文件名必须是完整路径(不包含存储空间名称))
     */
    private List<String> objectNameList;
    /**
     * 文件夹名称(用来新建文件夹或者查询该文件夹下的文件名称)
     */
    private String folderName;
}
