package cn.bs.bsmanagebasic.entity.oss;

import cn.bs.bsmanagebasic.service.ConfigurationService;
import com.google.common.base.Strings;
import lombok.Data;
import lombok.extern.slf4j.Slf4j;

/**
 * @packageName: cn.bs.bsmanagebasic
 * @className: OSSClient
 * @description: OSSClient
 * @author: liujs
 * @date: 2019/12/16 0016 下午 14:13
 * @version: 1.0
 */
@Data
@Slf4j
public class OssClient {
    private boolean myResult;
    private String endpoint;
    private String accessKeyId;
    private String accessKeySecret;

    public OssClient invoke(ConfigurationService configurationService){
        endpoint = configurationService.getConfigurationByCode("ossEndpoint").getOValue1();
        if(Strings.isNullOrEmpty(endpoint)){
            log.info("endpoint没有配置");
            myResult = true;
            return this;
        }
        accessKeyId = configurationService.getConfigurationByCode("alibbAccessKeyId").getOValue1();
        if(Strings.isNullOrEmpty(accessKeyId)){
            log.info("accessKeyId没有配置");
            myResult = true;
            return this;
        }
        accessKeySecret = configurationService.getConfigurationByCode("alibbAccessKeySecret").getOValue1();
        if(Strings.isNullOrEmpty(accessKeySecret)){
            log.info("accessKeySecret没有配置");
            myResult = true;
            return this;
        }
        myResult = false;
        return this;
    }
}
