package cn.bs.bsmanagebasic.entity.oss;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @packageName: cn.bs.bsmanagebasic.entity.oss
 * @className: bs-manage
 * @description: 获取Oss中文件详情类
 * @author: liujs
 * @date: 2019/12/19 0019 上午 10:42
 * @version: 1.0
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class OssFileInfoDto {
    /**
     * 文件名称
     */
    private String objectName;
    /**
     * 子文件夹名称
     */
    private String subFolderName;
    /**
     * 更新时间
     */
    private String updateTime;
    /**
     * 文件大小
     */
    private String fileSize;
    /**
     * 文件标签
     */
    private String eTag;
    /**
     * 文件地址
     */
    private String url;
    /**
     * 文件类型
     */
    private String fileType;
    /**
     * 文件访问权限(继承Bucket(Defaul);私有(Private);公共读(PublicRead);公告读写(PublicReadWrite))
     */
    private String fileACL;
    /**
     * 文件存储类型
     */
    private String fileStorageType;
}
