package cn.bs.bsmanagebasic.job;

import cn.bs.bsmanagebasic.service.ExpressDeptAccountConsumeService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

/**
 * @author sunjj
 * @version 1.0.0
 * @ClassName ScheduledJob.java
 * @Description TODO
 * @createTime 2019年12月04日 14:28:00
 */
@Component
@Slf4j
public class ScheduledJob {

    @Autowired
    private ExpressDeptAccountConsumeService consumeService;

    /**
     * @throws
     * @description 统计快递公司预充值消费, 并更新快递账户余额
     * @author sunjj
     * @updateTime
     */
    @Scheduled(fixedRate = (30 * 1000))
    public void updateExpressAccountAmount() {
        if(!consumeService.updateExpressAccountAmountLock()){
            return;
        }

        try {
            consumeService.updateExpressAccountAmount();
        } catch (Exception e) {
            log.error("updateExpressAccountAmount error - Exception: {}", e.getMessage());
        } finally {
            consumeService.updateExpressAccountAmountUNLock();
        }
    }
}
