package cn.bs.bsmanagebasic.service;

import cn.bs.bsmanagebasic.entity.ExpressDeptAccount;

/**
 * @author sunjj
 * @version 1.0.0
 * @ClassName ExpressDeptAccountService.java
 * @Description TODO
 * @createTime 2019年12月04日 17:09:00
 */
public interface ExpressDeptAccountService {
    /**
     * 从缓存中获取快递公司账户
     *
     * @param storeId 门店ID
     * @param expId   快递公司ID
     * @return
     */
    ExpressDeptAccount getAccount(Long storeId, Long expId);

    /**
     * 根据主键更新账户
     *
     * @param account
     * @return
     */
    int updateByPrimaryKeySelective(ExpressDeptAccount account);

    /**
     * 根据账号ID更新账户缓存
     *
     * @param id 账号ID
     */
    void upDateCacheByDeptId(Long id);

    /**
     * @param id
     * @return
     */
    int enableAccountById(Long id);

    /**
     * 删除账户
     *
     * @param id
     * @return
     */
    int deleteAccountById(Long id);

    ExpressDeptAccount selectAccountByStoreIdAndExpId(Long storeId, Long expId);

    int updateBalance(ExpressDeptAccount accountForUpdate, boolean isTransaction);
}
