package cn.bs.bsmanagebasic.service;

import cn.bs.bsmanagebasic.common.util.Pager;
import cn.bs.bsmanagebasic.entity.ExpressDept;
import cn.bs.bsmanagebasic.entity.ExpressDeptAccount;
import cn.bs.bsmanagebasic.entity.dto.ExpressAccountConsumeRecordDto;
import cn.bs.bsmanagebasic.entity.dto.ExpressAccountRechargeRecordDto;
import cn.bs.bsmanagebasic.entity.filter.DeliveryFilter;
import cn.bs.bsmanagebasic.entity.filter.ExpressDeptFilter;

import java.util.List;

/**
 * @author sunjj
 * @version 1.0.0
 * @ClassName ExpressDeptService.java
 * @Description TODO
 * @createTime 2019年11月18日 10:47:00
 */
public interface ExpressDeptService {

    void addDept(ExpressDept dept);

    Pager<ExpressDept> getDepts(ExpressDeptFilter filter);

    void editDept(ExpressDept dept);

    void addDeptAccount(ExpressDeptAccount account);

    Pager<ExpressDeptAccount> getDeptAccounts(ExpressDeptFilter filter);

    void editDeptAccount(ExpressDeptAccount account);

    List<ExpressDept> getDeptsForOption(Long expId);

    ExpressDept getDeptDetail(ExpressDeptFilter filter);

    void expressAccountRecharge(ExpressDeptFilter filter);

    boolean deleteById(Long id);

    boolean save(ExpressDept dept);

    boolean saveAcount(ExpressDeptAccount dept);

    boolean enableById(Long id);

    boolean enableAccountById(Long id);

    boolean deleteAccountById(Long id);

    Pager<ExpressAccountRechargeRecordDto> getRecords(ExpressDeptFilter filter);

    Pager<ExpressAccountConsumeRecordDto> getConsumeRecords(ExpressDeptFilter filter);

    Pager<ExpressAccountConsumeRecordDto> getDeliveries(ExpressDeptFilter filter);

}
