package cn.bs.bsmanagebasic.service;

import cn.bs.bsmanagebasic.common.util.Pager;
import cn.bs.bsmanagebasic.entity.dto.RoleListDto;
import cn.bs.bsmanagebasic.entity.dto.RoleMenuBindDto;
import cn.bs.bsmanagebasic.entity.sys.Role;
import cn.bs.bsmanagecommon.result.ResultBean;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * @author LiuJS
 * @Time 2021/4/26 17:46
 * @Desc
 * @Version 1.0
 */
public interface RoleService {
    /**
     * 角色列表
     * @return
     */
    Pager<Role> listRole(HttpServletRequest request, RoleListDto roleDto);

    /**
     * 获取角色
     * @param id
     * @return
     */
    Role getRole(Long id);

    /**
     * 添加角色
     * @param role
     * @return
     */
    boolean addRole(HttpServletRequest request, Role role);


    /**
     * 添加角色
     * @param role
     * @return
     */
    boolean updateRole(HttpServletRequest request,Role role);

    /**
     * 删除角色
     * @param id
     * @return
     */
    ResultBean deleteRole(HttpServletRequest request, Long id);

    /**
     * 获取角色资源
     * @param id
     * @return
     */
    Long[] getRoleMenu(HttpServletRequest request, Long id);

    /**
     * 绑定角色资源
     * @param roleMenuBindDto
     * @return
     */
    ResultBean bindRoleMenu(RoleMenuBindDto roleMenuBindDto);

    List<Role> listRoleAll(RoleListDto roleListDto);

    Long[]  getRoleTemplateMenu(Long roleTemplateId);


}
