package cn.bs.bsmanagebasic.service;

import cn.bs.bsmanagebasic.common.util.Pager;
import cn.bs.bsmanagebasic.entity.SmsRecord;
import cn.bs.bsmanagebasic.entity.TempNotice;
import cn.bs.bsmanagebasic.entity.filter.NoticeFilter;
import cn.bs.bsmanagebasic.entity.filter.SmsRecordFilter;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * 发送短信<br>
 *
 * @className: SmsService
 * @package: cn.bs.bsmanagebasic.service
 * @author: kael
 * @date: 2019/10/16 0016 下午 17:13
 */
public interface SmsService {
    /**
     * 根据条件发送短信
     * @param filter
     * @return
     */
    boolean resendSms(SmsRecordFilter filter);

    /**
     * 查询短信记录
     * @param filter
     * @return
     */
    List<SmsRecord> getSmsRecordList(SmsRecordFilter filter);

    Pager<SmsRecord> getList(SmsRecordFilter filter, HttpServletRequest request);

    Integer getCount(SmsRecordFilter filter);

    Pager<TempNotice> getNotice(NoticeFilter filter);

    boolean saveNotice(TempNotice notice);

    boolean deleteNotice(List<Integer> ids);
}
