package cn.bs.bsmanagebasic.service;

import cn.bs.bsmanagebasic.common.util.Pager;
import cn.bs.bsmanagebasic.entity.StoreStaff;
import cn.bs.bsmanagebasic.entity.User;
import cn.bs.bsmanagebasic.entity.dto.StoreStaffDto;
import cn.bs.bsmanagebasic.entity.filter.StoreStaffFilter;

import java.util.List;

/**
 * 门店外派员
 */
public interface StoreStaffService {

    /**
     * 获取门店外派员信息
     * @return
     */
    List<StoreStaffDto> getStoreStaffList();

    /**
     * 新增外派员
     * @param user
     * @return
     */
    boolean addStoreStaff(User user);

    /**
     * 修改外派员信息
     * @param storeStaff
     * @return
     */
    boolean updateStoreStaffById(User storeStaff);

    /**
     * 删除
     * @param userId
     * @return
     */
    boolean deleteStoreStaffById(String userId);


    /**
     * 查询
     * @param storeStaff
     * @return
     */
    List<StoreStaffDto> queryStoreStaff(StoreStaffFilter storeStaff);

    /**
     * 条数
     * @param filter
     * @return
     */
    Integer listCount(StoreStaffFilter filter);

    /**
     * 详情
     * @param userId
     * @return
     */
    User detailStaff(String userId);

    Pager<StoreStaffDto> getStoreStaffPage(StoreStaffFilter filter);
}
