package cn.bs.bsmanagebasic.service.impl;

import cn.bs.bsmanagebasic.dao.jeesite.AdLogMapper;
import cn.bs.bsmanagebasic.entity.AdLog;
import cn.bs.bsmanagebasic.entity.delivery.Delivery;
import cn.bs.bsmanagebasic.service.ADLogService;
import cn.bs.bsmanagebasic.service.DeliveryService;
import org.apache.logging.log4j.util.Strings;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @author sunjj
 * @version 1.0.0
 * @ClassName ADLogServiceImpl.java
 * @Description TODO
 * @createTime 2019年12月26日 14:47:00
 */
@Service
public class ADLogServiceImpl implements ADLogService {
    @Autowired
    private AdLogMapper adLogMapper;

    @Autowired
    private DeliveryService deliveryService;

    @Override
    public boolean saveLog(AdLog log) {
        if (null == log.getSource()) {
            return false;
        }

        // 2:来自微信公众号,需要特殊处理
        if (log.getSource().intValue() == 2) {
            String appid = log.getAppid();
            if (!Strings.isBlank(appid)) {
                log.setAppid(null);
                String[] ids = appid.split("&");
                if (null != ids && ids.length > 1) {
                    Delivery delivery = deliveryService.getById(Integer.valueOf(ids[0]), Integer.valueOf(ids[1]));
                    if (null != delivery) {
                        log.setStoreId(delivery.getStoreId());
                        log.setPhone(delivery.getUserPhone());
                    }
                }
            }
        }
        return adLogMapper.insert(log) > 0;
    }

}
