package cn.bs.bsmanagebasic.service.impl;

import cn.bs.bsmanagebasic.dao.jeesite.AddressCityMapper;
import cn.bs.bsmanagebasic.entity.AddressCity;
import cn.bs.bsmanagebasic.entity.AddressCityExample;
import cn.bs.bsmanagebasic.service.AddressCityService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author sunjj
 * @version 1.0.0
 * @ClassName AddressCityServiceImpl.java
 * @Description 城市列表
 * @createTime 2019年07月22日 15:55:00
 */
@Service
public class AddressCityServiceImpl implements AddressCityService {
    @Autowired
    private AddressCityMapper mapper;

    @Override
    public List<AddressCity> getCities(Integer provinceId) {
        AddressCityExample example = new AddressCityExample();
        if (null != provinceId) {
            AddressCityExample.Criteria criteria = example.createCriteria();
            criteria.andProvinceIdEqualTo(provinceId);

        }
        return mapper.selectByExample(example);
    }

    @Override
    public List<AddressCity> getByCityId(Long cityId) {
        AddressCityExample example = new AddressCityExample();
        AddressCityExample.Criteria criteria = example.createCriteria();
        criteria.andCityIdEqualTo(cityId);
        return mapper.selectByExample(example);
    }


}
