package cn.bs.bsmanagebasic.service.impl;

import cn.bs.bsmanagebasic.dao.jeesite.AddressDistrictMapper;
import cn.bs.bsmanagebasic.entity.AddressDistrict;
import cn.bs.bsmanagebasic.entity.AddressDistrictExample;
import cn.bs.bsmanagebasic.service.AddressDistrictService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author sunjj
 * @version 1.0.0
 * @ClassName AddressDistrictServiceImpl.java
 * @Description 地区列表
 * @createTime 2019年07月22日 15:53:00
 */
@Service
public class AddressDistrictServiceImpl implements AddressDistrictService {
    @Autowired
    private AddressDistrictMapper mapper;

    @Override
    public List<AddressDistrict> getDistricts(Long cityId) {
        AddressDistrictExample example = new AddressDistrictExample();
        if (null != cityId) {
            AddressDistrictExample.Criteria criteria = example.createCriteria();
            criteria.andCityIdEqualTo(cityId);
        }
        example.setOrderByClause("id");
        return mapper.selectByExample(example);
    }

    @Override
    public List<AddressDistrict> getByDistrictId(Long districtId) {
        AddressDistrictExample example = new AddressDistrictExample();
        AddressDistrictExample.Criteria criteria = example.createCriteria();
        criteria.andDistrictIdEqualTo(districtId);
        return mapper.selectByExample(example);
    }
}
