package cn.bs.bsmanagebasic.service.impl;

import cn.bs.bsmanagebasic.dao.jeesite.AddressProvinceMapper;
import cn.bs.bsmanagebasic.entity.AddressProvince;
import cn.bs.bsmanagebasic.entity.AddressProvinceExample;
import cn.bs.bsmanagebasic.service.AddressProvinceService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author sunjj
 * @version 1.0.0
 * @ClassName AddressProvinceServiceImpl.java
 * @Description 省列表
 * @createTime 2019年07月22日 15:54:00
 */
@Service
public class AddressProvinceServiceImpl implements AddressProvinceService {
    @Autowired
    private AddressProvinceMapper mapper;

    @Override
    public List<AddressProvince> getProvinces() {
        return mapper.selectByExample(null);
    }

    @Override
    public List<AddressProvince> getByProvinceId(Integer provinceId){
        AddressProvinceExample example = new AddressProvinceExample();
        AddressProvinceExample.Criteria criteria = example.createCriteria();
        criteria.andProvinceIdEqualTo(provinceId);
        return mapper.selectByExample(example);
    }
}
