package cn.bs.bsmanagebasic.service.impl;

import cn.bs.bsmanagebasic.config.AmapConfig;
import cn.bs.bsmanagebasic.entity.amap.GeoCodeResponse;
import cn.bs.bsmanagebasic.service.IAmapService;
import cn.bs.bsmanagebasic.utils.OkHttpUtil;
import com.alibaba.fastjson.JSON;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @ClassName AmapServiceImpl
 * @Description
 * @Author SunJJ
 * @Date 2020/7/8 10:40
 * @Version V1.0
 **/
@Service
public class AmapServiceImpl implements IAmapService {
    @Autowired
    private OkHttpUtil okHttpUtil;

    @Autowired
    private AmapConfig amapConfig;

    private static final String GEOCODE_URL = "https://restapi.amap.com/v3/geocode/geo?key=%s&address=%s&city=%s";

    @Override
    public GeoCodeResponse geocode(String address, String city) {
        String resp = okHttpUtil.doGet(String.format(GEOCODE_URL, amapConfig.getKey(), address, city));
        return JSON.parseObject(resp, GeoCodeResponse.class);
    }
}
