package cn.bs.bsmanagebasic.service.impl;

import cn.bs.bsmanagebasic.common.util.Pager;
import cn.bs.bsmanagebasic.dao.jeesite.ApiLogMapper;
import cn.bs.bsmanagebasic.entity.ApiLoggingEvent;
import cn.bs.bsmanagebasic.entity.filter.ApiLogFilter;
import cn.bs.bsmanagebasic.service.ApiLogService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @ProjectName: bs-manage
 * @Package: cn.bs.bsmanagebasic.service.impl
 * @ClassName: ApiLogServiceImpl
 * @Author: kexl
 * @Description: ${description}
 * @Date: 2019/10/22 14:06
 * @Version: 1.0
 */
@Service
public class ApiLogServiceImpl implements ApiLogService {

    @Autowired
    private ApiLogMapper apiLogMapper;

    @Override
    public Integer addApiLog(ApiLoggingEvent apiLoggingEvent) {
        apiLoggingEvent.setRequestMsg(apiLoggingEvent.getRequestMsg().length()>995?apiLoggingEvent.getRequestMsg().substring(0,995):apiLoggingEvent.getRequestMsg());
        apiLoggingEvent.setResponseMsg(apiLoggingEvent.getResponseMsg().length()>995?apiLoggingEvent.getResponseMsg().substring(0,995):apiLoggingEvent.getResponseMsg());
        return apiLogMapper.addApiLog(apiLoggingEvent);
    }

    @Override
    public Pager<ApiLoggingEvent> getList(ApiLogFilter filter){
        filter.initPage();
        filter.initSort();
        Pager<ApiLoggingEvent> pager = new Pager<ApiLoggingEvent>(apiLogMapper.listCount(filter), filter.getPageNumber(), filter.getPageSize());
        List<ApiLoggingEvent> deliveries = apiLogMapper.getList(filter);
        pager.setList(deliveries);
        return pager;
    }
}
