package cn.bs.bsmanagebasic.service.impl;

import cn.bs.bsmanagebasic.common.util.CacheTool;
import cn.bs.bsmanagebasic.dao.jeesite.ConfigurationMapper;
import cn.bs.bsmanagebasic.entity.Configuration;
import cn.bs.bsmanagebasic.service.ConfigurationService;
import cn.bs.bsmanagecommon.exception.BusinessException;
import org.apache.logging.log4j.util.Strings;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @ClassName ConfigUrationServiceImpl
 * @Description TODO
 * @Author kael
 * @Date 2019/9/16 0016 上午 9:58
 * @Version 1.0
 **/
@Service
public class ConfigurationServiceImpl implements ConfigurationService {

    @Autowired
    public ConfigurationMapper configurationMapper;

    @Override
    public Configuration getConfigurationByCode(String code){
        CacheTool cacheTool = CacheTool.initConfiguration();
        Configuration configurationByRedis = (Configuration) cacheTool.getBean(code);
        if (configurationByRedis != null) {
            return configurationByRedis;
        } else {
            Configuration configurationBySql = configurationMapper.getConfigurationByCode(code);
            if (configurationBySql != null) {
                cacheTool.saveBean(code, configurationBySql);
                return configurationBySql;
            }
            return null;
        }
    }

    @Override
    public List<Configuration> getList(){
        return configurationMapper.getList();
    }

    public boolean insert(Configuration configuration){
        return upRedisConfig(configuration, configurationMapper.insert(configuration)>0);
    }

    public boolean update(Configuration configuration){
        return upRedisConfig(configuration, configurationMapper.update(configuration)>0);
    }

    private boolean upRedisConfig(Configuration configuration, boolean fale) {
        if (fale) {
            CacheTool cacheTool = CacheTool.initConfiguration();
            cacheTool.saveBean(configuration.getOCode(), configuration);
        }
        return fale;
    }

    @Override
    public boolean save(Configuration configuration){
        if(configuration.getId() == null){
            return insert(configuration);
        }else{
            return update(configuration);
        }
    }

    @Override
    public boolean deleteById(Configuration configuration){
        if(configuration.getId() == null){
            throw new BusinessException("传入id不能为空");
        }
        boolean fale = configurationMapper.deleteById(configuration.getId()) > 0;
        if(fale && !Strings.isBlank(configuration.getOCode())){
            CacheTool cacheTool = CacheTool.initConfiguration();
            cacheTool.del(configuration.getOCode());
        }
        return fale;
    }

}
