package cn.bs.bsmanagebasic.service.impl;

import cn.bs.bsmanagebasic.common.util.CacheTool;
import cn.bs.bsmanagebasic.dao.jeesite.ExExpressTypeMapper;
import cn.bs.bsmanagebasic.entity.ExExpressType;
import cn.bs.bsmanagebasic.entity.ExExpressTypeExample;
import cn.bs.bsmanagebasic.service.ExpressService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author sunjj
 * @version 1.0.0
 * @ClassName ExpressServiceImpl.java
 * @Description 快递公司相关操作
 * @createTime 2019年07月23日 15:47:00
 */
@Service
public class ExpressServiceImpl implements ExpressService {

    @Autowired
    private ExExpressTypeMapper mapper;

    @Override
    public List<ExExpressType> getExpressWithSignBack() {
        ExExpressTypeExample example = new ExExpressTypeExample();
        ExExpressTypeExample.Criteria criteria = example.createCriteria();
        criteria.andIsdelEqualTo(0);
        criteria.andIsUnicomEqualTo(true);
        example.setOrderByClause("sort");
        return mapper.selectByExample(example);
    }

    @Override
    public List<ExExpressType> getAllExpress() {
        ExExpressTypeExample example = new ExExpressTypeExample();
        ExExpressTypeExample.Criteria criteria = example.createCriteria();
        criteria.andIsdelEqualTo(0);
        example.setOrderByClause("sort");
        return mapper.selectByExample(example);
    }

    @Override
    public ExExpressType getExpressById(Long expId) {
        return mapper.selectByPrimaryKey(expId);
    }

    /**
     * @description 从redis中获取快递公司信息。如果获取为null，从数据库中取出相关数据并保存到redis中
     * @author sunjj
     * @updateTime
     * @throws
     */
    @Override
    public ExExpressType getExpressFromCacheById(Long expId) {
        CacheTool cacheTool = CacheTool.initExpress();
        ExExpressType express = (ExExpressType) cacheTool.getBean(String.valueOf(expId));
        if (null == express) {
            express = mapper.selectByPrimaryKey(expId);
            if (null != express) {
                cacheTool.saveBean(String.valueOf(expId), express);
            }
        }
        return express;
    }
}
