package cn.bs.bsmanagebasic.service.impl;

import cn.bs.bsmanagebasic.config.RabbitConfig;
import cn.bs.bsmanagebasic.dao.jeesite.PickupQueueMapper;
import cn.bs.bsmanagebasic.dao.jeesite.StoreImeiMapper;
import cn.bs.bsmanagebasic.entity.PickupQueue;
import cn.bs.bsmanagebasic.entity.jiguang.ExtraBean;
import cn.bs.bsmanagebasic.entity.jiguang.JiguangBean;
import cn.bs.bsmanagebasic.service.ConfigurationService;
import cn.bs.bsmanagebasic.service.DeliveryService;
import cn.bs.bsmanagebasic.service.PickupQueueService;
import cn.bs.bsmanagebasic.utils.MD5;
import cn.bs.bsmanagecommon.exception.BusinessException;
import com.google.gson.Gson;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.time.LocalDateTime;
import java.util.*;

/**
 * 〈功能概述〉<br>
 *
 * @className: PickupQueueServiceImpl
 * @package: cn.bs.bsmanagebasic.service.impl
 * @author: kael
 * @date: 2019/11/6 0006 下午 14:39
 */
@Service
public class PickupQueueServiceImpl implements PickupQueueService {

    @Autowired
    public PickupQueueMapper pickupQueueMapper;

    @Autowired
    public DeliveryService deliveryService;

    private static int subscript = 0;

    @Autowired
    public ConfigurationService configurationService;

    @Autowired
    private RabbitConfig rabbitConfig;

    @Autowired
    private RabbitService rabbitService;

    @Resource(name = "storeImeiMapper")
    private StoreImeiMapper storeImeiMapper;

    private static Map<Integer,Integer> colors = new HashMap<>();

    @Override
    public String insert(PickupQueue pickupQueue){
        List<String> strings = deliveryService.getCount(pickupQueue);
        int count = strings.size();
        pickupQueue.setCreateTime(LocalDateTime.now());
        pickupQueue.setExpCount(count);
        pickupQueue.setSignCount(0);
        pickupQueue.setStatus(1);
        if(count != 0){
            try {
                if(pickupQueueMapper.getByPhone(pickupQueue.getUserPhone())!=null){
                    throw new BusinessException("");
                }
                String[] color = configurationService.getConfigurationByCode("colors").getOValue1().split(",");
                int subscript = 0;
                if(colors.get(pickupQueue.getStoreId())==null){
                    colors.put(pickupQueue.getStoreId(),0);
                }else{
                    subscript = colors.get(pickupQueue.getStoreId())<color.length-1?colors.get(pickupQueue.getStoreId())+1:0;
                    colors.put(pickupQueue.getStoreId(),subscript);
                }
                pickupQueue.setColor(color[subscript]);
                pickupQueueMapper.insert(pickupQueue);
            } catch (Exception e){
                e.printStackTrace();
                return getReturnMsg(count,pickupQueue);
            }
        }else{
            return "您没有快递在该蜂站";
        }
        return getReturnMsg(count,pickupQueue);
    }

    private String getReturnMsg(int count,PickupQueue pickupQueue) {
        jiGuangSend(pickupQueue);
        return "排队成功，请耐心排队取件";
    }

    private void jiGuangSend(PickupQueue pickupQueue) {
        JiguangBean jiguangBean = new JiguangBean();
        //all:全部 alias:根据别名推送 allIos:推送所有ios用户 allAndroid:推送所有安卓用户
        jiguangBean.setPushRange("alias");
        /*jiguangBean.setPushRange("all");*/
        //1.极光推送， 2.app内自定义推送
        jiguangBean.setPushType("1");
        jiguangBean.setNotification_title("排队通知");
        jiguangBean.setMsg_content(pickupQueue.getUserPhone()+"用户排队成功,点击直接进入排队取件页面");
        ExtraBean extraBean = new ExtraBean();
        //设置controller中的参数 跳转到哪个界面
        extraBean.setControllerIOS("WaitingQueueList");
        extraBean.setControllerAndroid("PaiDui");
        extraBean.setSound("paidui.m4a");
        extraBean.setType("3");
        jiguangBean.setExtraBean(extraBean);
        //TODO 设置推送到哪些手机上  (只推送到该门店的手机中)
        Collection<String> alias = new HashSet<>();
        //获取需要通知的设备号并且加密
        if (pickupQueue.getStoreId() == null){
            throw new BusinessException("");
        }
        List<String> imeiList = getStoreImei(pickupQueue.getStoreId());
        imeiList.forEach(imei -> alias.add(imei));
        jiguangBean.setAlias(alias);
        rabbitService.send(rabbitConfig.getJPushExchangeName(),rabbitConfig.getJPushRoutingKey(),new Gson().toJson(jiguangBean));
    }

    private List<String> getStoreImei(Integer storeId) {
        List<String> imeiByJiaMiList = new ArrayList<>();
        List<String> imeiList= storeImeiMapper.getImeiByStoreId(storeId);
        imeiList.forEach(imei -> imeiByJiaMiList.add(MD5.md5(imei)));
        return imeiByJiaMiList;
    }

}