package cn.bs.bsmanagebasic.service.impl;

import cn.bs.bsmanagebasic.config.MyMessagePostProcessor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.amqp.core.AmqpTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @ClassName RabbitService
 * @Description TODO
 * @Author kael
 * @Date 2019/9/11 0011 下午 17:23
 * @Version 1.0
 **/
@Service
@Slf4j
public class RabbitService {

    @Autowired
    private AmqpTemplate rabbitTemplate;

    /**
     * 发送消息
     * @param exchange
     * @param routingKey
     * @param info
     */
    public void send(String exchange, String routingKey, String info) {
        rabbitTemplate.convertAndSend(exchange, routingKey, info);
    }

    /**
     * 定时发送
     * @param queue
     * @param time
     * @param info
     */
    public void timingSend(String queue, Long time, final String info) {
        try {
            rabbitTemplate.convertAndSend(queue,(Object)info, new MyMessagePostProcessor(time));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}

