package cn.bs.bsmanagebasic.service.impl;

import cn.bs.bsmanagebasic.common.util.Pager;
import cn.bs.bsmanagebasic.dao.jisu.RoleMapper;
import cn.bs.bsmanagebasic.entity.Menu;
import cn.bs.bsmanagebasic.entity.User;
import cn.bs.bsmanagebasic.entity.dto.RoleListDto;
import cn.bs.bsmanagebasic.entity.dto.RoleMenuBindDto;
import cn.bs.bsmanagebasic.entity.sys.Role;
import cn.bs.bsmanagebasic.entity.sys.RoleMenu;
import cn.bs.bsmanagebasic.service.RoleService;
import cn.bs.bsmanagecommon.result.ResultBean;
import com.alibaba.fastjson.JSON;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.Date;
import java.util.List;

/**
 * @author LiuJS
 * @Time 2021/4/26 17:47
 * @Desc
 * @Version 1.0
 */
@Service
public class RoleServiceImpl implements RoleService {

    @Resource
    private RoleMapper roleMapper;

    @Override
    public Pager<Role> listRole(HttpServletRequest request,RoleListDto roleDto) {
        roleDto.initSort();
        roleDto.initPage();
        int count = roleMapper.getRoleCount(roleDto);
        Pager<Role> pager = new Pager(count, roleDto.getPageNumber(), roleDto.getPageSize());
        if(count > 0) {
            pager.setList(roleMapper.listRole(roleDto));
        }
        return pager;
    }

    @Override
    public Role getRole(Long id) {
       /* return roleMapper.selectById(id);*/
        return null;
    }

    @Override
    public boolean addRole(HttpServletRequest request, Role role) {
        role.setCreateTime(new Date());
        return roleMapper.addRole(role);
    }

    @Override
    public boolean updateRole(HttpServletRequest request, Role role) {
        return roleMapper.updateRole(role);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ResultBean deleteRole(HttpServletRequest request, Long id) {
        roleMapper.deleteRole(id);
        List<Role> roleList = roleMapper.getChildRole(id);
        if (roleList != null && roleList.size() > 0) {
            for (Role role: roleList) {
                deleteRole(request, role.getId());
            }
        }
        return new ResultBean();
    }



    @Override
    public Long[] getRoleMenu(HttpServletRequest request, Long id) {
        RoleMenu roleMenu = new RoleMenu();
        HttpSession session = request.getSession();
        User user = JSON.parseObject(session.getAttribute(session.getId()).toString(), User.class);
        roleMenu.setParentId(user.getRoleId());
        roleMenu.setId(id);
        Long[] resource = roleMapper.getRoleMenu(roleMenu);
        return resource;
    }

    @Override
    public ResultBean bindRoleMenu(RoleMenuBindDto roleMenuBindDto) {
        roleMapper.deleteRoleMenu(roleMenuBindDto);
        if (roleMenuBindDto.getMenuIds() != null && roleMenuBindDto.getMenuIds().length > 0) {
            roleMapper.addRoleMenu(roleMenuBindDto);
        }
        return new ResultBean();
    }

    /**
     * 查询所有的角色
     * @return
     */
    @Override
    public List<Role> listRoleAll(RoleListDto roleListDto) {
        return roleMapper.listRole(roleListDto);
    }

    @Override
    public Long[] getRoleTemplateMenu(Long roleId) {
        Long[] resource = roleMapper.getRoleTemplateMenu(roleId);
        return resource;
    }


}
