package cn.bs.bsmanagebasic.service.impl;

import cn.bs.bsmanagebasic.dao.jisu.StatisticsReportMapper;
import cn.bs.bsmanagebasic.entity.dto.StatisticsReportDto;
import cn.bs.bsmanagebasic.entity.User;
import cn.bs.bsmanagebasic.entity.filter.StatisticsReportFilter;
import cn.bs.bsmanagebasic.service.StatisticsReportService;
import com.alibaba.fastjson.JSON;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

/**
 *Time: 2021/5/13 15:00                                       
 * Author: zhangHP
 * @description: 统计
 */
@Service
public class StatisticsReportServiceImpl implements StatisticsReportService {

    @Resource
    private StatisticsReportMapper statisticsMapper;

    @Resource
    private HttpServletRequest request;

    /**
     * 根据快递公司进行统计 入库
     * @param filter
     * @return
     */
    @Override
    public List<StatisticsReportDto> countGroupByCompany(StatisticsReportFilter filter) {
        User user = getUser();
        Long storeId = user.getStoreId();
        if (user.getAdminType() == 2){
            filter.setStoreId(storeId);
        }
        // 设置默认查询条件 近一个月
        System.out.println(filter);
        if (null == filter.getStartTime()) {
            Calendar calendar = Calendar.getInstance();
            calendar.add(Calendar.MONTH, -1);
            long timeInMillis = calendar.getTimeInMillis();
            filter.setStartTime(new Date(timeInMillis));
        }
        if (null == filter.getEndTime()){
            filter.setEndTime(new Date());
        }
        return statisticsMapper.countGroupByCompany(filter);
    }

    //根据门店统计 入库
    @Override
    public List<StatisticsReportDto> countGroupByStore(StatisticsReportFilter filter) {
        User user = getUser();
        Long storeId = user.getStoreId();
        if (user.getAdminType() == 2){
            filter.setStoreId(storeId);
        }
        // 设置默认查询条件 近一个月
        if (null == filter.getStartTime()) {
            Calendar calendar = Calendar.getInstance();
            calendar.add(Calendar.MONTH, -1);
            long timeInMillis = calendar.getTimeInMillis();
            filter.setStartTime(new Date(timeInMillis));
        }
        if (null == filter.getEndTime()){
            filter.setEndTime(new Date());
        }
        return statisticsMapper.countGroupByStore(filter);
    }

    //根据外派员统计 入库
    @Override
    public List<StatisticsReportDto> countGroupByStoreStaff(StatisticsReportFilter filter) {
        User user = getUser();
        Long storeId = user.getStoreId();
        if (user.getAdminType() == 2){
            filter.setStoreId(storeId);
        }
        // 设置默认查询条件 近一个月
        if (null == filter.getStartTime()) {
            Calendar calendar = Calendar.getInstance();
            calendar.add(Calendar.MONTH, -1);
            long timeInMillis = calendar.getTimeInMillis();
            filter.setStartTime(new Date(timeInMillis));
        }
        if (null == filter.getEndTime()){
            filter.setEndTime(new Date());
        }
        return statisticsMapper.countGroupByStoreStaff(filter);
    }

    /**
     * 获取当前登录用户
     * @return
     */
    private User getUser(){
        HttpSession session = request.getSession();
        User user = JSON.parseObject(session.getAttribute(session.getId()).toString(), User.class);
        return user;
    }
}
