package cn.bs.bsmanagecommon.filter;

import lombok.Data;
import org.apache.logging.log4j.util.Strings;

/**
 * 过滤基类<br>
 *
 * @className: Filter
 * @package: cn.bs.bsmanagebasic.entity.filter
 * @author: kael
 * @date: 2019/10/17 0017 上午 9:38
 */
@Data
public class Filter{
    private static final int MAX_PAGENUMBER = 100;
    private static final int MIN_PAGENUMBER = 1;
    private static final int MIN_PAGE = 1;

    /** 每页显示的条目数*/
    private Integer pageSize;
    /** 当前页码*/
    private Integer pageNumber;
    private Long count;

    /**
     * 排序字段
     */
    private String sort;
    /**
     * 排序方式
     */
    private String sortType;

    public Filter initPage(){
        if(pageSize!=null){
            if(pageSize.compareTo(MAX_PAGENUMBER)>0){
                this.pageSize = MAX_PAGENUMBER;
            }
            if(pageSize.compareTo(MIN_PAGENUMBER)<0){
                this.pageSize = MIN_PAGENUMBER;
            }
        }else{
            this.pageSize = 10;
        }
        if(pageNumber == null || pageNumber.compareTo(MIN_PAGE)<0){
            this.pageNumber = MIN_PAGE;
        }
        this.count = new Long((this.pageNumber-1) * this.pageSize);
        return this;
    }

    public Filter initSort(){
        if(Strings.isBlank(sort)){
            this.sort = "createTime";
        }
        if(Strings.isBlank(sortType)){
            this.sortType = "desc";
        }
        return this;
    }
}
